"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var actionCreators_1 = require("../../actionCreators");
var defaultOptions_1 = __importDefault(require("../../defaultOptions"));
var enums_1 = require("../../enums");
var CellUtils_1 = require("../../Utils/CellUtils");
var ComponentUtils_1 = require("../../Utils/ComponentUtils");
var SortUtils_1 = require("../../Utils/SortUtils");
var HeaderFilterButton_1 = __importDefault(require("../HeaderFilterButton/HeaderFilterButton"));
var SortIcon_1 = __importDefault(require("../SortIcon/SortIcon"));
var HeadCellContent = function (props) {
    var column = props.column, dispatch = props.dispatch, sortingMode = props.sortingMode, filteringMode = props.filteringMode, childComponents = props.childComponents;
    var sortingEnabled = SortUtils_1.isSortingEnabled(sortingMode, column);
    var onClick = sortingEnabled ? function () {
        dispatch(actionCreators_1.updateSortDirection(column.key));
    } : undefined;
    var _a = ComponentUtils_1.getElementCustomization({
        className: defaultOptions_1.default.css.theadCellContent + " " + (sortingEnabled ? 'ka-pointer' : ''),
        onClick: onClick
    }, props, childComponents.headCellContent), elementAttributes = _a.elementAttributes, content = _a.content;
    var refToElement = React.useRef(null);
    React.useLayoutEffect(function () {
        CellUtils_1.checkPopupPosition(column, refToElement, dispatch);
    }, [column, dispatch]);
    return (React.createElement("div", __assign({}, elementAttributes, { ref: refToElement }),
        content || React.createElement("span", null, column.title),
        column.sortDirection && sortingEnabled && (React.createElement(SortIcon_1.default, { column: column, dispatch: dispatch, childComponents: childComponents })),
        (filteringMode === enums_1.FilteringMode.HeaderFilter) && (React.createElement(HeaderFilterButton_1.default, { column: column, dispatch: dispatch, childComponents: childComponents }))));
};
exports.default = HeadCellContent;
