"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var actionCreators_1 = require("../actionCreators");
exports.isCellResizeShown = function (isResizable, columnResizing) { return !!((isResizable !== false) && (columnResizing || isResizable)); };
exports.getMouseMove = function (currentWidth, minWidth, startX, key, dispatch) { return function (event) {
    var newWidth = event.screenX - startX;
    if (newWidth !== currentWidth) {
        newWidth = exports.getValidatedWidth(newWidth, minWidth);
        dispatch(actionCreators_1.resizeColumn(key, newWidth));
    }
}; };
exports.getValidatedWidth = function (newWidth, minWidth) {
    if (newWidth < minWidth) {
        return minWidth;
    }
    return newWidth;
};
exports.isNumberWidth = function (width) { return width && typeof width === 'number'; };
exports.getMinWidth = function (style) {
    var minWidth = 20;
    if (!style) {
        return minWidth;
    }
    var styleMinWidth = style.minWidth;
    if (exports.isNumberWidth(styleMinWidth)) {
        minWidth = styleMinWidth;
    }
    return minWidth;
};
