"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var DataUtils_1 = require("./DataUtils");
exports.getValidatedEditableCells = function (_a) {
    var data = _a.data, _b = _a.editableCells, editableCells = _b === void 0 ? [] : _b, columns = _a.columns, rowKeyField = _a.rowKeyField, validation = _a.validation;
    return editableCells.map(function (cell) {
        var _a;
        var column = columns.find(function (c) { return c.key === cell.columnKey; });
        var updatedRowData = (_a = data) === null || _a === void 0 ? void 0 : _a.find(function (d) { return DataUtils_1.getValueByField(d, rowKeyField) === cell.rowKeyValue; });
        var value = cell.hasOwnProperty('editorValue') ? cell.editorValue : DataUtils_1.getValueByField(updatedRowData, cell.columnKey);
        return __assign(__assign({}, cell), { validationMessage: validation && validation({
                column: column,
                rowData: updatedRowData,
                value: value
            }) });
    });
};
exports.getEditableCellsByData = function (data, rowKeyField, columns) {
    var _a;
    var editableCells = [];
    (_a = data) === null || _a === void 0 ? void 0 : _a.forEach(function (rowData) {
        var rowKeyValue = DataUtils_1.getValueByField(rowData, rowKeyField);
        columns.forEach(function (column) {
            editableCells.push({ columnKey: column.key, rowKeyValue: rowKeyValue });
        });
    });
    return editableCells;
};
exports.addColumnsToRowEditableCells = function (editableCells, columns, rowKeyValue) {
    var newEditableCells = __spreadArrays(editableCells);
    columns.forEach(function (column) {
        if (column.isEditable !== false
            && !newEditableCells.some(function (e) { return e.columnKey === column.key && e.rowKeyValue === rowKeyValue; })) {
            newEditableCells.push({
                columnKey: column.key,
                rowKeyValue: rowKeyValue
            });
        }
    });
    return newEditableCells;
};
exports.removeDataKeysFromSelectedRows = function (selectedRows, data, rowKeyField) {
    var newSelectedRows = selectedRows.filter(function (rowKeyValue) {
        return !data.some(function (d) { return DataUtils_1.getValueByField(d, rowKeyField) === rowKeyValue; });
    });
    return newSelectedRows;
};
exports.getUpdatedFocused = function (props, action, funcToUpdate) {
    var _a, _b;
    if (!((_b = (_a = props) === null || _a === void 0 ? void 0 : _a.focused) === null || _b === void 0 ? void 0 : _b.cell))
        return props;
    var newFocused = { cell: funcToUpdate(props.focused.cell, props, action.settings) };
    return __assign(__assign({}, props), { focused: newFocused });
};
